public class main {

    public static void main(String[] args) {


        // values above integer space will produce errors

        String ausdruck = "((5 + 1) + (3+4))";

        Lexer lexer = new Lexer();


        // [23x] + [0,5x^2 - 1]


        lexer.lex(ausdruck).forEach(token -> {
            System.out.println(token.getTokenString());
            System.out.println(token.getTokenType());
        });


        Parser p = new Parser();

        AstExpression result = p.parse(lexer.lex(ausdruck));


        printAst(result);

/*
        do {

            try {
                System.out.println(result.astBinaryOp.astExpression1.astValue.astNumber.astDigitWoz.astDigitWozContent);
            } catch (NullPointerException n) {

                System.out.println(result.astBinaryOp.astExpression1.astValue.astDecimal.astDigitBeforeComma.astDigitWoz.astDigitWozContent
                        + "."
                        + result.astBinaryOp.astExpression1.astValue.astDecimal.astDigitAfterComma.astDigitWoz.astDigitWozContent);
            }

            System.out.println(result.astBinaryOp.astOperator.astOperator);

            if (result.astBinaryOp.astExpression2.astValue != null) {

                try {
                    System.out.println(result.astBinaryOp.astExpression2.astValue.astNumber.astDigitWoz.astDigitWozContent);
                } catch (NullPointerException n) {

                    System.out.println(result.astBinaryOp.astExpression2.astValue.astDecimal.astDigitBeforeComma.astDigitWoz.astDigitWozContent
                            + "."
                            + result.astBinaryOp.astExpression2.astValue.astDecimal.astDigitAfterComma.astDigitWoz.astDigitWozContent);
                }


                break;

            } else {

                result = result.astBinaryOp.astExpression2;

            }


        } while (true);

 */

    }

    public static void printAst(AstExpression astExpression) {

        if(astExpression.astExpression != null) {
            System.out.print("(");
            printAst(astExpression.astExpression);
            System.out.print( ")");
            return;
        }

        if(astExpression.astValue != null) {

            if(astExpression.astValue.astNumber != null) {

                System.out.print(astExpression.astValue.astNumber.astDigitWoz.astDigitWozContent);

            } else {
                System.out.println(astExpression.astValue.astDecimal.astDigitBeforeComma.astDigitWoz.astDigitWozContent
                        + "."
                        + astExpression.astValue.astDecimal.astDigitAfterComma.astDigitWoz.astDigitWozContent);
            }
            return;
        }

        printAst(astExpression.astBinaryOp.astExpression1);
        System.out.print(astExpression.astBinaryOp.astOperator.astOperator);
        printAst(astExpression.astBinaryOp.astExpression2);

    }

}
